<?php

//--默认截取200个汉字作为摘要，可自行修改--

define(B525_EXCERPT_LENGTH,200); //修改数字"200"即可

//--替代WP的摘要函数--

remove_filter('get_the_excerpt', 'wp_trim_excerpt');
remove_filter('the_excerpt', 'mul_excerpt'); //WP中文工具箱兼容
add_filter('get_the_excerpt','wp_trim_excerpt_b525');

if (!function_exists('mb_substr')) { //如果不支持mb_substr,咱自己来一个
    function mb_substr($str, $start, $len = '', $encoding='utf-8'){
        $limit = strlen($str);
        for ($s = 0; $start > 0;--$start) {
            if ($s >= $limit)
                break;
            if ($str[$s] <= "\x7F")
                ++$s;
            else {
                ++$s; 
                while ($str[$s] >= "\x80" && $str[$s] <= "\xBF")
                    ++$s;
            }
        }
        if ($len == '')
            return substr($str, $s);
        else
            for ($e = $s; $len > 0; --$len) {
                if ($e >= $limit)
                    break;
                if ($str[$e] <= "\x7F")
                    ++$e;
                else {
                    ++$e;
                    while ($str[$e] >= "\x80" && $str[$e] <= "\xBF" && $e < $limit)
                        ++$e;
                }
            }
        return substr($str, $s, $e - $s);
    }
}

function wp_trim_excerpt_b525($text) {
   if ( '' == $text ) {
      $text = get_the_content('');
      $text = strip_shortcodes( $text );
      $text = str_replace(']]>', ']]&gt;', $text);
      $text = strip_tags($text);
	  $text = mb_substr($text,0,B525_EXCERPT_LENGTH,'utf-8');
      }
   return $text;
}


?>